﻿using rkismvvm.Views;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace rkismvvm.ViewsModels
{
    public class MyTaskViewModel : BaseViewModel
    {
        private RelayCommand _back;
        public RelayCommand Back
        {
            get
            {
                return _back ??
                (_back = new RelayCommand(obj =>
                {
                    MenuWindow menu = new MenuWindow();
                    menu.Show();
                    foreach (var win in App.Current.Windows)
                    {
                        if (win is MyTasks mytasks)
                        {
                            mytasks.Close();
                        }
                    }
                }));
            }
        }
        private ObservableCollection<Task> _tasks;
        public ObservableCollection<Task> Tasks
        {
            get => _tasks;
            set
            {
                _tasks = value;
                OnPropertyChanged();
            }
        }
        private User _user;
        public User User
        {
            get => _user;
            set
            {
                _user = value;
                OnPropertyChanged();
            }
        }

        private Task _selectedtask;
        public Task SelectedTask
        {
            get => _selectedtask;
            set
            {
                _selectedtask = value;
                OnPropertyChanged();
            }
        }
        private RelayCommand? _update;
        public RelayCommand UpdateCommand
        {
            get
            {
                return _update ??
                    (_update = new RelayCommand(x =>

                    {
                        if (_selectedtask== null)
                        {
                            MessageBox.Show("Выберете задачу", "Изменение статуса", MessageBoxButton.OK);
                            return;

                        }
                        int st= _selectedtask.StatusTaskId;
                        TaskHelpContext context = new TaskHelpContext();
                        var task = context.Tasks.FirstOrDefault(x => x.TaskId == _selectedtask.TaskId);


                        if (task.StatusTaskId==3)
                        {
                            st = 1;
                        }
                        else
                        {
                            st++;
                        }
                        task.StatusTaskId = st;
                        task.StatusTask = context.StatusTasks.Find(st);
                        context.SaveChanges();
                        Tasks.Clear();
                        Tasks = new ObservableCollection<Task>(context.Tasks.Where(x => x.UserGive.UserId == _user.UserId));
                        OnPropertyChanged(nameof(Tasks));
                    }
                    ));
            }
        }


        public MyTaskViewModel()
        {
            _user = MainWindowViewModel.CurrentUser;
            TaskHelpContext context = new TaskHelpContext();
            Tasks = new ObservableCollection<Task>(context.Tasks.Where(x => x.UserGive.UserId == _user.UserId));
        }

    }
}
