﻿using rkismvvm.Views;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace rkismvvm.ViewsModels
{
    public class TaskHistoryViewModel : BaseViewModel
    {
        private RelayCommand _back;
        public RelayCommand Back
        {
            get
            {
                return _back ??
                (_back = new RelayCommand(obj =>
                {
                    MenuWindow menu = new MenuWindow();
                    menu.Show();
                    foreach (var win in App.Current.Windows)
                    {
                        if (win is TaskHistory taskhistory)
                        {
                            taskhistory.Close();
                        }
                    }
                }));
            }
        }
        private ObservableCollection<Task> _tasks;
        public ObservableCollection<Task> Tasks
        {
            get => _tasks;
            set
            {
                _tasks = value;
                OnPropertyChanged();
            }
        }
        private User _user;
        public User User
        {
            get => _user;
            set
            {
                _user = value;
                OnPropertyChanged();
            }
        }

        public TaskHistoryViewModel()
        {
            _user = MainWindowViewModel.CurrentUser;
            TaskHelpContext context = new TaskHelpContext();
            Tasks = new ObservableCollection<Task>(context.Tasks.Where(x => x.UserTake.UserId == _user.UserId && x.StatusTaskId==3));
        }

    }
}
