﻿using Microsoft.EntityFrameworkCore;
using rkismvvm.Views;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace rkismvvm.ViewsModels
{
    public class TasksViewModel: BaseViewModel
    {
        private RelayCommand _back;
        public RelayCommand Back
        {
            get
            {
                return _back ??
                (_back = new RelayCommand(obj =>
                {
                    MenuWindow menu = new MenuWindow();
                    menu.Show();
                    foreach (var win in App.Current.Windows)
                    {
                        if (win is Tasks tasks)
                        {
                            tasks.Close();
                        }
                    }
                }));
            }
        }
        private ObservableCollection<Task> _tasks;
        public ObservableCollection<Task> Tasks
        {
            get => _tasks;
            set
            {
                _tasks = value;
                OnPropertyChanged();
            }
        }
        private Task _selectedtask;
        public Task SelectedTask
        {
            get => _selectedtask;
            set
            {
                _selectedtask = value;
                OnPropertyChanged();
            }
        }
        private RelayCommand? _update;
        public RelayCommand UpdateCommand
        {
            get
            {
                return _update ??
                    (_update = new RelayCommand(x =>

                    {
                        if (_selectedtask == null)
                        {
                            MessageBox.Show("Выберете задачу", "Изменение статуса", MessageBoxButton.OK);
                            return;

                        }
                        TaskHelpContext context = new TaskHelpContext();
                        var task = context.Tasks.FirstOrDefault(x => x.StatusTaskId == _selectedtask.StatusTaskId );
                        task.StatusTaskId = 2;
                        task.StatusTask = context.StatusTasks.Find(2);
                        context.SaveChanges();
                        Tasks.Clear();
                        Tasks = new ObservableCollection<Task>(context.Tasks.Where(x => x.StatusTaskId!=3));
                        OnPropertyChanged(nameof(Tasks));
                    }
                    ));
            }
        }
        private string _login;
        public string Login
        {
            get => _login;
            set
            {
                _login = value;
                OnPropertyChanged();
            }
        }
        private RelayCommand? _find;
        public RelayCommand Find
        {
            get
            {
                return _find ??
                (_find = new RelayCommand(x =>
                {
                    TaskHelpContext context = new TaskHelpContext();
                    if (_login==null || _login =="")
                    {
                        Tasks.Clear();
                        Tasks = new ObservableCollection<Task>(context.Tasks.Where(x => x.StatusTaskId != 3));
                        return;
                    }
                    var task = context.Tasks.Where(x => x.UserGive.Login == _login);
                    Tasks.Clear();
                    Tasks = new ObservableCollection<Task>(task);
                    OnPropertyChanged(nameof(Tasks));
                }));
            }
        }

        public TasksViewModel()
        {
            TaskHelpContext context = new TaskHelpContext();
            Tasks = new ObservableCollection<Task>(context.Tasks.Where(x => x.StatusTaskId!=3));
        }

    }
}
